####This function is the main code for the Hurricane Risk Project.
##Prepares the interpolated best track data for use in futher projects. 
#We reqiore three packages, the ismev package is only necessary if you plan on using the original HurRisk code

dir<-"Y:/class"  #Current directory
require(foreign) ###May be needed for exporting data not used as of 8/26
require(ismev)   ###required
require(maps)    ###display USA map overlay
fd<-function(x,d=dir){paste(d,x,sep="/")}
# Original Data: load("R:/globalhurricanes/hurricanedata/best.interp.2006.R")
# The new data is made from this data set see HurRiskMain.R in R:/hurrisk to update.
# We always reload functions, but other options are possible
load(fd("data/best.use.R")) ###Creates best.use list with components data and index, 
source(fd("funs/selectData.R"))
source(fd("funs/ismevplus.R")) #Kept for use with HurRisk
load(fd("data/landGrid.R"))
tmp<-readLines(n=5)
   lat     lon
  17.28  -61.79
  25.08  -77.35
  24.65  -82.85
  29.33  -91.38        
tmp1<-read.table(t1<-textConnection(tmp,"r"),header=T)
close(t1)
class4<-findtracks(loc=tmp1,r=200,umin=34)  





tr0<-findtracks()  ##How to find tracks, (You can add lon at lats as well
3
tr1<-findtracks(loc=data.frame(lon=c(-100,-88),lat=c(32,22)))
tr2<-findtracks(loc=data.frame(lon=c(-100,-88),lat=c(28,22)),r=200)
tr2hur<-findtracks(umin=64,loc=data.frame(lon=c(-100,-88),lat=c(28,22)),r=200)  ##Only tracks that are hurricanes through all the points.
tr3<-findtracks(r=200)
3



####Some files may require downloading...
###Original HurRisk tests...
test0<-HurRisk(r=200,distunits="nm",velunits="kt",field="Wmax",threshold=64,se=c(1851,2006))
test1<-HurRisk(r=250,distunits="km",velunits="m/s",field="WmaxS",threshold=32,se=c(1851,2006))
test2<-HurRisk()
testfinal<-HurRisk(r=c(250,250),distunits="km",velunits="kt",field="WmaxS",threshold=50,se=c(1851,2006))
print("Examine test0,test1, test2 and testfinal output")

####For General Data Analysis (Only storms > 35 kt)
all.1<-get.max(lon=-67,lat=27,r=3000,se=c(1851,2006),field="WmaxS")
all.11<-all.1[c("Sid","SYear","lon","lat","WmaxS")]
all.2<-get.max(lon=-67,lat=27,r=3000,se=c(1851,2006),field="DWmaxDt")
all.22<-all.2[c("Sid","SYear","lon","lat","DWmaxDt","WmaxS")]
colnames(all.22)<-c("Sid","SYear","lon.d","lat.d","DWmaxDt","WmaxS.d")

write.csv(all.1,"R:/globalhurricanes/hurricanedata/atl.max.csv")
####Using new tools:
all.123<-get.max.flags(x=best.use,fields=c("WmaxS","DWmaxDt"),flag="",se=c(1851,2006),field.suffix=c("",".d"))
write.csv(all.123,"R:/globalhurricanes/hurricanedata/atl.max2new.csv")
max.usa<-get.max.flags(x=best.use,se=c(1851,2006),flag="Region.4") ###see defaults
write.csv(max.usa,"R:/globalhurricanes/hurricanedata/usa.max2.csv")
######For plots:


WW<-make.counts(all.12)
WX<-apply(t(WW),2,rev)
barplot(WX[1:3,50:156]) ##cat0, cat1, cat2
YY<-make.counts(all.12,cum.sum=T)
